/* 
 * File:   adf7030_tools.h
 * Author: afilmer
 *
 * Created on December 8, 2019, 5:38 PM
 */

#ifndef ADF7030_TOOLS_H
#define	ADF7030_TOOLS_H

#include <xc.h>

//Registers
#define MISC_FW 0x400042B4
#define PROFILE_MONITOR1 0x2000038C
#define PROFILE_GPCON0_3 0x20000394
#define SPI_HOST_PNTR0 0x40001800
#define SPI_HOST_PNTR1 0x40001804
#define SPI_HOST_PNTR2 0x40001808
#define SM_DATA_CALIBRATION 0x20000130
#define PROFILE_RADIO_CAL_CFG1 0x2000036C
#define PROFILE_RADIO_DIG_TX_CFG0 0x20000304
#define PROFILE_RADIO_DIG_TX_CFG1 0x20000308
#define PROFILE_RADIO_DIG_TX_CFG2 0x2000030C
#define GENERIC_PKT_TEST_MODES0 0x20000548
#define PROFILE_REF_CLK_CFG 0x200002E8
#define GENERIC_PKT_FRAME_CFG1 0x20000500
#define GENERIC_PKT_FRAME_CFG0 0x200004FC
#define GENERIC_PKT_FRAME_CFG2 0x20000504
#define GENERIC_PKT_BUFF_CFG0 0x200004F4
#define GENERIC_PKT_BUFF_CFG1 0x200004F8
#define IRQ_CTRL_STATUS0 0x40003808
#define IRQ_CTRL_STATUS1 0x4000380C
#define IRQ_CTRL_MASK0 0x40003800
#define GENERIC_PKT_LIVE_LINK_QUAL 0x20000538
#define GENERIC_PKT_TICK_CFG 0x2000052C
#define PROFILE_RSSI_CFG 0x20000374


//Other
#define CAL_ENABLE 0x20002971
#define CAL_DISABLE 0x20002A21

//States
#define PHY_SLEEP 0x00
#define PHY_OFF 0x01
#define PHY_ON 0x02
#define PHY_RX 0x03
#define PHY_TX 0x04
#define CFG_DEV 0x05
#define CCA 0x06
#define DO_CAL 0x09
#define GPCLK 0x10
#define MON 0x0A
#define LFRC_CAL 0x0C

void reset_radio();
uint32_t read_RnPL(uint32_t);
void write_RnPL(uint32_t, uint32_t);
void set_pntr(uint32_t, uint8_t);
void write_BPL(uint8_t, uint8_t*, uint32_t);
void read_BPL(uint8_t, uint8_t*,uint32_t);
void poll_CMDREADY_IDLE();
uint8_t is_CMDREADY_IDLE();
void configRadio();
void calibrateRadio();
void radio_command(uint8_t);
void enableSPICMD();
void write_bits(uint32_t,uint8_t,uint8_t,uint32_t);
uint32_t read_bits(uint32_t,uint8_t,uint8_t);


#endif	/* ADF7030_TOOLS_H */

