#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "spi_tools.h"
#include "adf7030_tools.h"
#include "pin_config.h"
#include <sys/attribs.h>
#include <proc/p32mz0512efe064.h>
#include "UARTTools.h"


#include "CS_def_NOT_sensor_board.h"
#include "packet.h"



uint32_t RX_SIZE;
void setup_adf_rx();
Packet packet;


void __ISR (_EXTERNAL_2_VECTOR, IPL7SRS)
    INT2Handler(void)
    {
        LATBbits.LATB13 = 1 - LATBbits.LATB13;      //GP4    

//        read_RnPL(PROFILE_RSSI_CFG);
//        read_RnPL(GENERIC_PKT_LIVE_LINK_QUAL);



        uint8_t read_buff[RX_SIZE];
        read_BPL(1,packet.buffer,RX_SIZE);              //Read payload buffer from pointer 1 bc PTR_RX associated w pointer 1

        // Write out read_buff data to UART
        printf("%lu, %f", packet.data.time, packet.data.altitude);
        int i;
        for (i=0; i<8; i++)
        {
            printf(", %f, %f, %f", packet.data.kx_data[i].x_data, packet.data.kx_data[i].y_data, packet.data.kx_data[i].z_data);
        }
        printf("\n");
        
    
    
        write_bits(IRQ_CTRL_STATUS0,1,11,1);        //Clear the SM_IDLE interrupt
        IFS0bits.INT2IF = 0;
   //////////////////////////////////////// Not sure if I need this
        //poll_CMDREADY_IDLE();
   ////////////////////////////////////     
        radio_command(PHY_RX);
    }

void config_int2_int()
{
    ANSELBbits.ANSB15 = 0;      //turn off analog on B15
    TRISBbits.TRISB15 = 1;      //make input
    INT2Rbits.INT2R = 0b0011;   //assign ext int 2 to RPB15 (GP0)
//    PMCONbits.ON = 0;
//    PMAENbits.PTEN = 0;
//    ANSELBbits.ANSB8 = 0;
//    TRISBbits.TRISB8 = 1;
//    INT2Rbits.INT2R = 0b0010;



    IFS0bits.INT2IF = 0;        //reset flag
    IPC3bits.INT2IP = 7;        //priority 7
    INTCONbits.INT2EP = 1;      //polarity rising edge
    IEC0bits.INT2IE = 1;        //enable
    
}

void config_general_int()
{
    __builtin_enable_interrupts();  //global interrupt enable
    INTCONbits.MVEC = 1;            //Multi vector interrupt 
}


int main(int argc, char** argv) 
{
    setup_adf_rx();
    serial_init();
    
    TRISBbits.TRISB13 = 0;      //gp4
    LATBbits.LATB13 = 1;
    
    config_general_int();
    config_int2_int();

    while(1){}

    return (EXIT_SUCCESS);
}




void setup_adf_rx()
{
    reset_radio();      
    enableSPICMD();                                                             //Enables SPI commands to be sent to radio
    spi_init();                                                                 //Enable PIC SPI
     
    poll_CMDREADY_IDLE();                                                       //Configure ADF
    configRadio();                                                              //Configure ADF

    RX_SIZE = 100;                                                     //Set RX_SIZE = 100
    write_bits(GENERIC_PKT_BUFF_CFG1,9,0,RX_SIZE);                              //Set RX_SIZE = 100
    write_bits(GENERIC_PKT_FRAME_CFG1,12,0,RX_SIZE);                            //Set Payload Size to RX_SIZE
    
    write_bits(PROFILE_REF_CLK_CFG,1,26,1);                                     //Modify configuration such that CLK_TYPE = 1 (oscillator is XTAL)
    calibrateRadio();                                                           //Write calibration file to memory
    write_RnPL(SM_DATA_CALIBRATION, CAL_ENABLE);
////// SET up ADF interrupt
    write_bits(IRQ_CTRL_MASK0,1,11,1);                                          //set SM_IDLE_IRQ0
//    write_bits(PROFILE_GPCON0_3,6,24,0x6);                                    //Set Pin3 to be IRQ_OUT0
    write_bits(PROFILE_GPCON0_3,6,0,0x6);                                       //Set Pin0 to be IRQ_OUT0
///////
    radio_command(CFG_DEV);                                                     //Send command to do configuration
    poll_CMDREADY_IDLE();                                                       //Wait for CMD_READY, TRANSITION_STATE==IDLE
    radio_command(PHY_ON);                                                      //Sequence to perform calibration
    poll_CMDREADY_IDLE(); 
    radio_command(DO_CAL);
    poll_CMDREADY_IDLE(); 
    write_RnPL(SM_DATA_CALIBRATION, CAL_DISABLE);
    
    uint32_t PTR_RX = read_bits(GENERIC_PKT_BUFF_CFG0,11,0)*4 + 0x20000000;     //READ PTR_RX
    set_pntr(PTR_RX,1);                                                         //set pointer 1 as RX payload pointer
}
